100 REMark **********************************************************************
110 REMark mps.bas :   Make a PostScript file out of a plain ASCII text file
120 REMark
130 REMark SMSQ/E SBasic port of the original mps C source from Richard Urena.
140 REMark Port done by Marcel Kilgus based on version 2.1.0 from June 1999.
150 REMark The port quite much resembles the C original, even the comments have
160 REMark been preserved. What isn't included however is the complete command
170 REMark line handling. Parameters can be adjusted in the "Init" procedure
180 REMark at the end. Source and target can be adjusted in the first 2 lines.
190 REMark
200 REMark Version 1.0.0   January 2002
210 REMark
220 REMark PostScript is a registered trademark of Adobe Systems Incorporated.
230 REMark
240 REMark Copyright (C) 1999, Richard Urena.  All rights reserved.
250 REMark
260 REMark This program is free software; you can redistribute it and/or modify
270 REMark it under the terms of the GNU General Public License as published by
280 REMark the Free Software Foundation; either version 2 of the License, or
290 REMark (at your option) any later version.   You can find the GNU
300 REMark General Public License in the file COPYING in the source directory,
310 REMark or at http://www.gnu.org
320 REMark
330 REMark This program is distributed in the hope that it will be useful,
340 REMark but WITHOUT ANY WARRANTY; without even the implied warranty of
350 REMark MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
360 REMark GNU General Public License for more details.
370 REMark
380 REMark You should have received a copy of the GNU General Public License
390 REMark along with this program; if not, write to the Free Software
400 REMark Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
410 REMark
420 REMark ***********************************************************************
430 :
440 REMark ------------------------------------------------------------------
450 REMark m a i n
460 REMark ------------------------------------------------------------------
470 :
480 gs% = FOP_OVER("par4")
490 ic% = FOP_IN("win1_boot")
500 INIT
510 Y = TopOfPage
520 ContinueX = MarginLeftMeasure - 2 * FontCharWidth
530 :
540 REMark Some sanity checking
550 :
560 IF CleanBreakLimit% > MaxOutputChars% / 2 THEN
570   CleanBreakLimit% = 0
580 END IF
590 IF (TabStop% < 1) OR (TabStop% > 16)
600   TabStop% = 8
610 END IF
620 :
630 REMark Let's go
640 :
650 WriteFile
660 IF AbsolutelyNothingDone% THEN
670   PSEject
680 END IF
690 :
700 CLOSE #gs%
710 CLOSE #ic%
720 STOP
730 :
740 REMark ------------------------------------------------------------------
750 REMark G e t L i n e
760 REMark ------------------------------------------------------------------
770 :
780 DEFine FuNction GetLine
790   LOCal C%, I%, J%, k%, Last%, Nxt%, EndNow%
800   :
810   REMark * what we do at this point depends on the outcome of
820   REMark * the previous call to this function
830   :
840   EndNow% = 0
850   IF Embedded_FF% THEN
860     PSEject
870     PSBeginPage
880     I% = Last_FF% + 1
890   ELSE
900     IF LineContinues%
910       I% = LastLineBreak%
920     ELSE
930       IF EOF(#ic%) THEN
940         EndNow% = 1
950       ELSE
960         INPUT#ic%, LineBuffer$
970         trim
980         ExpandTabs
990         I% = 0
1000       END IF
1010     END IF
1020   END IF
1030   IF EndNow% THEN
1040     Embedded_FF% = 0
1050     LineContinues% = 0
1060     RETurn 0
1070   END IF
1080   :
1090   REMark * at this point we have an input line (or portion thereof)
1100   REMark * on the input buffer, and the tabs have been expanded.
1110   REMark *
1120   REMark * "i" points to the beginning of the line (offset into
1130   REMark * the input buffer).
1140   REMark *
1150   REMark * we need to see if what remains of this line is still
1160   REMark * too long, and if so, break up the line accordingly.
1170   :
1180   LineContinues% = (LEN(LineBuffer$) - I%) > MaxOutputChars%
1190   IF (LineContinues%)
1200     :
1210     REMark * search backwards from the
1220     REMark * break for a space to fold at, subject to
1230     REMark * CleanBreakLimit.  i.e., we're trying to fold
1240     REMark * the line somewhat elegantly.
1250     :
1260     k% = 0
1270     FOR J% = MaxOutputChars% - 1 TO 0 STEP -1
1280       C% = CODE(LineBuffer$(I% + J%))
1290       IF (C% = 32) OR (k% >= CleanBreakLimit%) THEN EXIT
1300       k% = k% + 1
1310     END FOR
1320     IF FOLDLONG% AND (J% >= 0) AND (k% < CleanBreakLimit%) THEN
1330       Nxt% = I% + J% + 1
1340       REPeat
1350         IF J% = 0 OR LineBuffer$(I% + J%) <> ' ' THEN EXIT
1360         J% = J% -1
1370       END REPeat
1380       Last% = I% + J%
1390     ELSE
1400       Last% = I% + MaxOutputChars% - 1
1410       Nxt% = Last% + 1
1420     END IF
1430   END IF
1440   :
1450   REMark * transfer the line (or portion thereof) to be printed
1460   :
1470   Line$ = "": I% = 1
1480   FOR I% = 1 TO LEN(LineBuffer$)
1490     C% = CODE(LineBuffer$(I%))
1500     IF C% = 14 THEN EXIT
1510     Line$ = Line$ & CHR$(C%)
1520     IF LineContinues% AND I% >= Last% THEN EXIT
1530   END FOR
1540   :
1550   REMark * finally, keep a record of the current state, for use
1560   REMark * by the next call to the function
1570   :
1580   Embedded_FF% = C% = 14
1590   IF Embedded_FF% THEN Last_FF% = I%
1600   :
1610   REMark * if we are truncating instead of folding, turn off some
1620   REMark * warnings
1630   :
1640   IF NOT FOLDLONG%
1650     LineContinues% = 0
1660     Truncated% = 0
1670   END IF
1680   IF LineContinues% THEN LastLineBreak% = Nxt%
1690   LastLineContinues% = LineContinues%
1700   RETurn 1
1710 END DEFine
1720 :
1730 REMark ------------------------------------------------------------------
1740 REMark t r i m
1750 REMark get rid of the trailing newline (left there by fgets)
1760 REMark and any trailing whitespace on the input line
1770 REMark ------------------------------------------------------------------
1780 :
1790 DEFine PROCedure trim
1800   LOCal L%
1810   FOR L% = 1 TO LEN(LineBuffer$)
1820     IF LineBuffer$(L%) <> CHR$(10) OR LineBuffer$(L%) <> " " THEN EXIT L%
1830   END FOR L%
1840   IF L% > 1 THEN LineBuffer$ = LineBuffer$(L% TO)
1850 END DEFine
1860 :
1870 REMark ------------------------------------------------------------------
1880 REMark E x p a n d T a b s
1890 REMark tabs are expanded into corresponding spaces.
1900 REMark
1910 REMark this only works with monospaced fonts
1920 REMark ------------------------------------------------------------------
1930 :
1940 DEFine PROCedure ExpandTabs
1950   REMark * if a tab is encountered, make sure the character
1960   REMark * immediately preceding it is a space.  if not,
1970   REMark * insert a space prior to expanding the tab
1980   REMark *
1990   REMark * As strings are handled differently in Basic this routine
2000   REMark * differs a bit from the C implementation (but really just a bit).
2010   :
2020   Target$ = ""
2030   FOR L% = 1 TO LEN(LineBuffer$)
2040     IF LineBuffer$(L%) <> CHR$(9) THEN
2050       Target$ = Target$ & LineBuffer$(L%)
2060     ELSE
2070       IF (L% > 1) THEN
2080         IF LineBuffer$(L% - 1) <> ' ' THEN Target$ = Target$ & ' '
2090       END IF
2100       Target$ = Target$ & FILL$(" ", TabStop% - (LEN(Target$) MOD TabStop%))
2110     END IF
2120   END FOR
2130   LineBuffer$ = Target$
2140 END DEFine
2150 :
2160 REMark ------------------------------------------------------------------
2170 REMark P S L i n e O u t
2180 REMark ------------------------------------------------------------------
2190 :
2200 DEFine PROCedure PSLineOut(L$, X, Y)
2210   PRINT#gs%, "("  &L$ & ")";
2220   PRINT_USING#gs%, " ###.# ###.# S", X, Y
2230   PRINT#gs%
2240 END DEFine
2250 :
2260 REMark ------------------------------------------------------------------
2270 REMark P S W r i t e L i n e
2280 REMark ------------------------------------------------------------------
2290 :
2300 DEFine PROCedure PSWriteLine
2310   LOCal I%, C%, Blank%, FirstOut%, X
2320   IF AtBottom% THEN
2330     PSEject
2340     PSBeginPage
2350   END IF
2360   IF LastLineContinues% THEN PSLineOut CONTINUECHAR, ContinueX, Y
2370   Blank% = 1: C% = 0: I% = 0
2380   OutputLine$ = ""
2390   FOR I% = 1 TO LEN(Line$)
2400     C% = CODE(Line$(I%))
2410     :
2420     REMark control chars. not previously dealt with are thrown out
2430     IF C% < 32 THEN NEXT I%
2440     :
2450     REMark don't include leading withespace as such
2460     IF Blank% AND (C% <> 32) THEN
2470       FirstOut% = I%
2480       Blank% = 0
2490     END IF
2500     :
2510     IF (C% > 127)
2520       REMark per Adobe's recommendation, make the output 7-bit only
2530       OutputLine$ = OutputLine$ & "\" & C%
2540     ELSE
2550       REMark things that need quoting inside a PostScript string
2560       IF (C% = CODE("(")) OR (C% = CODE(")")) OR (C% = CODE("\")) THEN
2570         OutputLine$ = OutputLine$ & "\"
2580       END IF
2590       OutputLine$ = OutputLine$ & CHR$(C%)
2600     END IF
2610   END FOR
2620   :
2630   IF NOT Blank% THEN
2640     X = MarginLeftMeasure + (FirstOut% - 1) * FontCharWidth
2650     PSLineOut OutputLine$(FirstOut% TO), X, Y
2660   END IF
2670   :
2680   IF LastLineContinues% OR NOT(Blank%) THEN AbsolutelyNothingDone% = 0
2690   PageIsEmpty% = 0
2700   Y = Y - FontLineSkip
2710 END DEFine
2720 :
2730 REMark ------------------------------------------------------------------
2740 REMark P S B e g i n P a g e
2750 REMark ------------------------------------------------------------------
2760 :
2770 DEFine PROCedure PSBeginPage
2780   PRINT#gs%, \"%%Page: ";PageNo%;" ";PageNo%;" "
2790   PageCounter% = PageCounter% + 1
2800 END DEFine
2810 :
2820 REMark ------------------------------------------------------------------
2830 REMark P S E j e c t
2840 REMark ------------------------------------------------------------------
2850 :
2860 DEFine PROCedure PSEject
2870   PageNo% = PageNo% + 1
2880   PRINT#gs%, "P"
2890   Y = TopOfPage
2900 END DEFine
2910 :
2920 REMark ------------------------------------------------------------------
2930 REMark A t B o t t o m %
2940 REMark ------------------------------------------------------------------
2950 :
2960 DEFine FuNction AtBottom%
2970   RETurn (Y - FontLineSkip) < MarginBottomMeasure
2980 END DEFine
2990 :
3000 REMark ------------------------------------------------------------------
3010 REMark P S S t a r t B l a n k P a g e
3020 REMark ------------------------------------------------------------------
3030 :
3040 DEFine PROCedure PSStartBlankPage
3050   PSBeginPage
3060   PSLineOut " ", MarginLeftMeasure, Y
3070   PageIsEmpty% = 0
3080 END DEFine
3090 :
3100 REMark ------------------------------------------------------------------
3110 REMark W r i t e F i l e
3120 REMark ------------------------------------------------------------------
3130 :
3140 DEFine PROCedure WriteFile
3150   PSWriteProlog
3160   PRINT#gs%, \"% ------ begin file: QPC ------ %"
3170   PSBeginPage
3180   REPeat
3190     IF NOT GetLine THEN EXIT
3200     PSWriteLine
3210   END REPeat
3220   IF NOT PageIsEmpty% THEN PSEject
3230   IF AbsolutelyNothingDone% THEN PSEject
3240   IF Truncated% THEN
3250     PRINT "Error: Line truncated"
3260   END IF
3270   PSWriteTrailer
3280 END DEFine
3290 :
3300 REMark ------------------------------------------------------------------
3310 REMark P S W r i t e P r o l o g
3320 REMark ------------------------------------------------------------------
3330 :
3340 DEFine PROCedure PSWriteProlog
3350   :
3360   : REMark Comments
3370   :
3380   PRINT#gs%, "%!PS-Adobe-3.0"
3390   PRINT#gs%, "%%Creator: MPS SBASIC port 1.0"
3400   PRINT#gs%, "%%CreationDate: ";DATE$
3410   PRINT#gs%, "%%DocumentFonts: "; FontFace$
3420   PRINT#gs%, "%%LanguageLevel: 1"
3430   PRINT#gs%, "%%Orientation: Portrait"
3440   PRINT#gs%, "%%Pages: (atend)"
3450   PRINT#gs%, "%%PageOrder: Ascend"
3460   PRINT#gs%, "%%EndComments"\
3470   :
3480   : REMark Prolog
3490   :
3500   PRINT#gs%, \"%BeginProlog"
3510   PRINT#gs%, "/S {moveto show} bind def"
3520   PRINT#gs%, "/P {showpage} bind def"
3530   PRINT#gs%, "%EndProlog"
3540   :
3550   : REMark Setup
3560   :
3570   PRINT#gs%, \"%%BeginSetup"
3580   PRINT#gs%, "% Change the encoding vector to Latin-1 (ISO-8859-1)"
3590   PRINT#gs%, "/";FontFace$;" findfont"
3600   PRINT#gs%, "dup length dict begin"
3610   PRINT#gs%, "        {1 index /FID ne {def} {pop pop} ifelse} forall"
3620   PRINT#gs%, "        /Encoding ISOLatin1Encoding def"
3630   PRINT#gs%, "        currentdict"
3640   PRINT#gs%, "end"
3650   PRINT#gs%, "/";FontFace$;"-ISOLatin1 exch definefont pop"
3660   PRINT#gs%, "% Scale to the desired size"
3670   PRINT#gs%, "/";FontFace$;"-ISOLatin1 findfont ";FontPointSize;" scalefont setfont"
3680   PRINT#gs%, "%%EndSetup"
3690 END DEFine
3700 :
3710 REMark ------------------------------------------------------------------
3720 REMark P S W r i t e T r a i l e r
3730 REMark ------------------------------------------------------------------
3740 :
3750 DEFine PROCedure PSWriteTrailer
3760   PRINT#gs%, \"%%Trailer"
3770   PRINT#gs%, "%%Pages: ";PageCounter%
3780   PRINT#gs%, "%%EOF"
3790 END DEFine
3800 :
3810 DEFine PROCedure ValidMargins
3820   MarginTopMeasure = MarginTopMeasure * Measurement(MarginTopUnits)
3830   MarginBottomMeasure = MarginBottomMeasure * Measurement(MarginBottomUnits)
3840   MarginLeftMeasure = MarginLeftMeasure * Measurement(MarginLeftUnits)
3850   MarginRightMeasure = MarginRightMeasure * Measurement(MarginRightUnits)
3860   :
3870   REMark they all must be non-negative
3880   :
3890   IF (MarginTopMeasure < 0) OR (MarginBottomMeasure < 0) OR (MarginRightMeasure < 0) OR (MarginLeftMeasure < 0) THEN
3900     PRINT "Error, bad margins"
3910     STOP
3920   END IF
3930   :
3940   REMark and they must leave a printable area
3950   :
3960   IF (PaperWidth% - MarginLeftMeasure - MarginRightMeasure < FontCharWidth) OR (PaperHeight% - MarginTopMeasure - MarginBottomMeasure < FontLineSkip) THEN
3970     PRINT "Error, bad margins"
3980     STOP
3990   END IF
4000 END DEFine
4010 :
4020 REMark ------------------------------------------------------------------
4030 REMark Initialisation. This differs somewhat from the original MPS
4040 REMark ------------------------------------------------------------------
4050 :
4060 DEFine PROCedure INIT
4070   REMark Default paper
4080   REMark    0 = letter
4090   REMark    1 = legal
4100   REMark    2 = a4
4110   DEFAULTPAPER% = 2
4120   :
4130   REMark Default font
4140   REMark    0 = Courier 9 point
4150   REMark    1 = Courier 10 point
4160   REMark    2 = Courier 12 point
4170   DEFAULTFONT% = 0
4180   :
4190   REMark Fold long lines?
4200   REMark    1 = yes
4210   REMark    0 = truncate
4220   FOLDLONG% = 1
4230   :
4240   REMark Default measurement unit
4250   REMark    0 = inches
4260   REMark    1 = points
4270   REMark    2 = milimeters
4280   REMark    3 = centimeters
4290   DEFAULTUNITS% = 3
4300   :
4310   REMark Margins in term of default measurement
4320   MarginRightMeasure = 1
4330   MarginLeftMeasure = 1
4340   MarginTopMeasure = 1
4350   MarginBottomMeasure = 1
4360   MarginRightUnits = DEFAULTUNITS%
4370   MarginLeftUnits = DEFAULTUNITS%
4380   MarginTopUnits = DEFAULTUNITS%
4390   MarginBottomUnits = DEFAULTUNITS%
4400   :
4410   REMark Expand tabs to how many spaces
4420   TabStop% = 8
4430   :
4440   DIM Measurement(3)
4450   Measurement(0) = 72:       REMark inch
4460   Measurement(1) = 1:        REMark point
4470   Measurement(2) = 2.834646: REMark millimeter
4480   Measurement(3) = 28.34646: REMark centimeter
4490   :
4500   DIM PaperWidths%(2)
4510   DIM PaperHeights%(2)
4520   PaperWidths%(0) = 612: PaperHeights%(0) = 792
4530   PaperWidths%(1) = 612: PaperHeights%(1) = 1008
4540   PaperWidths%(2) = 595: PaperHeights%(2) = 842
4550   :
4560   PaperWidth% = PaperWidths%(DEFAULTPAPER%)
4570   PaperHeight% = PaperHeights%(DEFAULTPAPER%)
4580   :
4590   FONTCOUNT% = 3
4600   DIM FontNames$(FONTCOUNT% - 1, 16)
4610   DIM FontFaces$(FONTCOUNT% - 1, 16)
4620   DIM FontCharWidths(FONTCOUNT% - 1)
4630   DIM FontPointSizes(FONTCOUNT% - 1)
4640   DIM FontAscends(FONTCOUNT% - 1)
4650   DIM FontLineSkips(FONTCOUNT% - 1)
4660   FontNames$(0)="courier9" : FontFaces$(0) = "Courier": FontCharWidths(0) = 5.4: FontPointSizes(0) = 9 : FontAscends(0) = 4.6 : FontLineSkips(0) = 10.8
4670   FontNames$(1)="courier10": FontFaces$(1) = "Courier": FontCharWidths(1) = 6:   FontPointSizes(1) = 10: FontAscends(1) = 5.1 : FontLineSkips(1) = 12
4680   FontNames$(2)="coutier12": FontFaces$(2) = "Courier": FontCharWidths(2) = 7.2: FontPointSizes(2) = 12: FontAscends(2) = 6.12: FontLineSkips(2) = 14.4
4690   :
4700   FontFace$ = FontFaces$(DEFAULTFONT%)
4710   FontCharWidth = FontCharWidths(DEFAULTFONT%)
4720   FontPointSize = FontPointSizes(DEFAULTFONT%)
4730   FontAscend = FontAscends(DEFAULTFONT%)
4740   FontLineSkip = FontLineSkips(DEFAULTFONT%)
4750   :
4760   ValidMargins
4770   :
4780   MaxOutputChars% = PaperWidth% - MarginLeftMeasure - MarginRightMeasure - 2 * FontCharWidth
4790   ContinueX = MarginLeftMeasure - 2 * FontCharWidth
4800   Embedded_FF% = 0: Last_FF% = 0: LastLineContinues% = 0: LineContinues% = 0: LastLineBreak% = 0
4810   AbsolutelyNothingDone% = 1
4820   TopOfPage = PaperHeight% - MarginTopMeasure - FontAscend
4830   PageIsEmpty% = 1
4840   PageCounter% = 0
4850   PageNo% = 1
4860   CleanBreakLimit% = 12
4870 END DEFine
4880
